package top.ninwoo.edgecenter;

import org.junit.After;
import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import top.ninwoo.edgecenter.entity.ClusterConfig;
import top.ninwoo.edgecenter.entity.ContainerDescription;
import top.ninwoo.edgecenter.service.ClusterService;
import top.ninwoo.utils.entity.DockerContainer;

import java.util.ArrayList;
import java.util.List;

/**
 * @Author joliu
 * @Description 测试ClusterService
 * @Date　Create in 下午4:02 2019/10/20
 */
@RunWith(SpringRunner.class)
@SpringBootTest
public class ClusterServiceTest {
    @Autowired
    ClusterService clusterService;
    long clusterId = 12312l;

    @Test
    public void testInitContainers() {
        // 构建一个容器组配置
        ClusterConfig clusterConfig = new ClusterConfig();
        clusterConfig.setId(clusterId);
        clusterConfig.setOwner("joliu");
        ContainerDescription containerDescription = new ContainerDescription();
        containerDescription.setMode("normal");
        containerDescription.setReplicas(2);
        DockerContainer container = new DockerContainer();
        container.setName("Run");
        container.setCommand("sh");
        container.setImage("joliu/networktest");
        containerDescription.setDockerContainer(container);

        List<ContainerDescription> cds = new ArrayList<>();
        cds.add(containerDescription);

        ContainerDescription containerDescription1 = new ContainerDescription();
        containerDescription1.setMode("normal");
        containerDescription1.setReplicas(3);
        DockerContainer container1 = new DockerContainer();
        container1.setName("APP");
        container1.setCommand("sh");
        container1.setImage("joliu/networktest");
        containerDescription1.setDockerContainer(container1);

        cds.add(containerDescription1);

        clusterConfig.setDockers(cds);

        long id = clusterService.initContainers(clusterConfig);
        Assert.assertEquals(id, clusterId);

        Assert.assertTrue(clusterService.getClusterIds().contains(clusterId));
        System.out.println(clusterService.getContainerIdsByClusterId(clusterId, "APP"));
        clusterService.createNetwork(clusterId, "APP");
    }

    @Test
    public void testCreateOvsNetwork() {
        // TODO: 这里只是使用了底层的网络组件，还应该使用配置文件格式的参数创建网络
        // 创建一个ovs网桥

        // 创建一个
    }

    @After
    public void testRemoveContainers() {
        clusterService.removeContainersByClusterId(clusterId);
    }
}
