package top.ninwoo.utils.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import top.ninwoo.utils.service.DockerService;
import top.ninwoo.utils.service.OVSService;
import top.ninwoo.utils.service.OvsDockerService;
import top.ninwoo.utils.util.LinuxCtlUtils;
import top.ninwoo.utils.util.OvsDockerUtils;

@Service
public class OvsDockerServiceImpl implements OvsDockerService {
    @Autowired
    OvsDockerUtils ovsDockerUtils;

    @Autowired
    OVSService ovsService;

    @Autowired
    DockerService dockerService;

    @Override
    public String addPort(String bridgeName, String devName, String containerId, String ip) {
        // 做一些校验
        if(!ovsService.isBridge(bridgeName)) {
            throw new RuntimeException("网桥[" + bridgeName + "]不存在！");
        }
        if(!dockerService.hasRunningContainer(containerId)) {
            throw new RuntimeException("容器[" + containerId + "]不存在");
        }

        return ovsDockerUtils.addPort(bridgeName, devName, containerId, ip);
    }
}
