package top.ninwoo.utils;

import org.junit.Assert;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import top.ninwoo.utils.config.DockerConfig;
import top.ninwoo.utils.entity.DockerContainer;
import top.ninwoo.utils.service.DockerService;
import top.ninwoo.utils.util.LinuxCtlUtils;

import java.util.ArrayList;
import java.util.List;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = DockerConfig.class)
public class DockerServiceTests {
    @Autowired
    private LinuxCtlUtils linuxCtlService;

    @Autowired
    private DockerService dockerService;

    @Test
    public void testRunLinuxCmd() {
        String input = "testRunLinuxCmd";
        String cmd = "echo " + input;
        String result = linuxCtlService.runCmd(cmd);
        Assert.assertEquals(input, result);

        cmd = "cat 1xxaaf";
        result = linuxCtlService.runCmd(cmd);
        Assert.assertEquals("Error: cat: 1xxaaf: 没有那个文件或目录", result);
    }

    @Test
    public void testSudo() {
        String result = linuxCtlService.runCmd("echo Vudo3423 | sudo -S ovs-vsctl show");
        System.out.println(result);
    }

    /*@Test
    public void testUpdateDockerService() {
        dockerService.updateContainersList(true);
        List<DockerContainer> allContainers = dockerService.getAllContainers();
        allContainers.forEach(c -> {
            System.out.println(c.getId() + ":" + c.getStatus());
        });
    }*/

    @Test
    public void testRunDockerService() {
        DockerContainer container = new DockerContainer();
        List<String> names = new ArrayList<String>();
        container.setName("Router4");
        container.setImage("joliu/networktest");
        container.setCommand("sh");
        try {
            DockerContainer dockerContainer = dockerService.runDocker(container);
            Assert.assertTrue(dockerService.deleteDockerById(dockerContainer.getId()));
        } catch (RuntimeException ex) {
            Assert.assertEquals("Run Docker failed!", ex.getMessage());
        }
    }
}
